<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>eRPC Generator (erpcgen): cpptempl.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<link href="customdoxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eRPC Generator (erpcgen)
   &#160;<span id="projectnumber">Rev. 1.4.0</span>
   </div>
   <div id="projectbrief">NXP Semiconductors</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('cpptempl_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">cpptempl.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (c) 2010-2014 Ryan Ginstrom</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// Copyright (c) 2014 Martinho Fernandes</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// Copyright (c) 2014-2016 Freescale Semiconductor, Inc.</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">// Permission is hereby granted, free of charge, to any person obtaining a copy</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">// of this software and associated documentation files (the &quot;Software&quot;), to deal</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">// in the Software without restriction, including without limitation the rights</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">// copies of the Software, and to permit persons to whom the Software is</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">// furnished to do so, subject to the following conditions:</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">// The above copyright notice and this permission notice shall be included in</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">// all copies or substantial portions of the Software.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">// THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">// THE SOFTWARE.</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#pragma once</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#ifdef _WIN32</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#pragma warning(disable : 4996) // &#39;std::copy&#39;: Function call with parameters that may be unsafe - this call relies on</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;                                <span class="comment">// the caller to check that the passed values are correct. To disable this warning, use</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;                                <span class="comment">// -D_SCL_SECURE_NO_WARNINGS. See documentation on how to use Visual C++ &#39;Checked</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;                                <span class="comment">// Iterators&#39;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#pragma warning(disable : 4512) // &#39;std::copy&#39;: Function call with parameters that may be unsafe - this call relies on</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;                                <span class="comment">// the caller to check that the passed values are correct. To disable this warning, use</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;                                <span class="comment">// -D_SCL_SECURE_NO_WARNINGS. See documentation on how to use Visual C++ &#39;Checked</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;                                <span class="comment">// Iterators&#39;</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#define NOEXCEPT                // hide unsupported noexcept keyword under VC++</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#define NOEXCEPT noexcept</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#endif // NOEXCEPT</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#if __MINGW32__</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="preprocessor">#define NOTHROW throw() // add throw() keyword under MinGW</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="preprocessor">#define NOTHROW</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="preprocessor">#endif // NOTHROW</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#include &lt;boost/lexical_cast.hpp&gt;</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;<span class="preprocessor">#include &lt;unordered_map&gt;</span></div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacecpptempl.html">cpptempl</a> {</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="comment">// various typedefs</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword">class </span>data_ptr;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">class </span>data_map;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="keyword">class </span>DataMap;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="keyword">class </span>DataTemplate;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="keyword">typedef</span> std::vector&lt;data_ptr&gt; data_list;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="comment">// data classes</span></div><div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="classcpptempl_1_1_data.html">   65</a></span>&#160;<span class="keyword">class </span><a class="code" href="classcpptempl_1_1_data.html">Data</a></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;{</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classcpptempl_1_1_data.html">Data</a>() = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> empty() = 0;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keyword">virtual</span> std::string getvalue();</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keyword">virtual</span> data_list &amp;getlist();</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classcpptempl_1_1data__map.html">data_map</a> &amp;getmap();</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">int</span> getint() <span class="keyword">const</span>;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> dump(<span class="keywordtype">int</span> indent = 0) = 0;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;};</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="classcpptempl_1_1_data_bool.html">   77</a></span>&#160;<span class="keyword">class </span><a class="code" href="classcpptempl_1_1_data_bool.html">DataBool</a> : <span class="keyword">public</span> <a class="code" href="classcpptempl_1_1_data.html">Data</a></div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;{</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keywordtype">bool</span> m_value;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <a class="code" href="classcpptempl_1_1_data_bool.html">DataBool</a>(<span class="keywordtype">bool</span> value)</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    : m_value(value)</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    {</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    }</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    std::string getvalue();</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">int</span> getint() <span class="keyword">const</span>;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keywordtype">bool</span> empty();</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> dump(<span class="keywordtype">int</span> indent = 0);</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;};</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div><div class="line"><a name="l00092"></a><span class="lineno"><a class="line" href="classcpptempl_1_1_data_int.html">   92</a></span>&#160;<span class="keyword">class </span><a class="code" href="classcpptempl_1_1_data_int.html">DataInt</a> : <span class="keyword">public</span> <a class="code" href="classcpptempl_1_1_data.html">Data</a></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;{</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <span class="keywordtype">int</span> m_value;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <a class="code" href="classcpptempl_1_1_data_int.html">DataInt</a>(<span class="keywordtype">int</span> value)</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    : m_value(value)</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    {</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    }</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <a class="code" href="classcpptempl_1_1_data_int.html">DataInt</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> value)</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    : m_value(value)</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    {</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    }</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    std::string getvalue();</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">int</span> getint() <span class="keyword">const</span>;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <span class="keywordtype">bool</span> empty();</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> dump(<span class="keywordtype">int</span> indent = 0);</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;};</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="classcpptempl_1_1_data_value.html">  111</a></span>&#160;<span class="keyword">class </span><a class="code" href="classcpptempl_1_1_data_value.html">DataValue</a> : <span class="keyword">public</span> <a class="code" href="classcpptempl_1_1_data.html">Data</a></div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;{</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    std::string m_value;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <a class="code" href="classcpptempl_1_1_data_value.html">DataValue</a>(<span class="keyword">const</span> std::string &amp;value)</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    : m_value(value)</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    {</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    }</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <a class="code" href="classcpptempl_1_1_data_value.html">DataValue</a>(std::string &amp;&amp;value)</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    : m_value(std::move(value))</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    {</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    }</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    std::string getvalue();</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">int</span> getint() <span class="keyword">const</span>;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    <span class="keywordtype">bool</span> empty();</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> dump(<span class="keywordtype">int</span> indent = 0);</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;};</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno"><a class="line" href="classcpptempl_1_1_data_list.html">  130</a></span>&#160;<span class="keyword">class </span><a class="code" href="classcpptempl_1_1_data_list.html">DataList</a> : <span class="keyword">public</span> <a class="code" href="classcpptempl_1_1_data.html">Data</a></div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;{</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    data_list m_items;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <a class="code" href="classcpptempl_1_1_data_list.html">DataList</a>(<span class="keyword">const</span> data_list &amp;items)</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    : m_items(items)</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    {</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    }</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <a class="code" href="classcpptempl_1_1_data_list.html">DataList</a>(data_list &amp;&amp;items)</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    : m_items(std::move(items))</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    {</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    }</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    data_list &amp;getlist();</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    <span class="keywordtype">bool</span> empty();</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    <span class="keywordtype">void</span> dump(<span class="keywordtype">int</span> indent = 0);</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;};</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div><div class="line"><a name="l00148"></a><span class="lineno"><a class="line" href="classcpptempl_1_1data__ptr.html">  148</a></span>&#160;<span class="keyword">class </span><a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a></div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;{</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>() {}</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<span class="keyword">const</span> T &amp;data)</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    {</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        this-&gt;operator=(data);</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    }</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<a class="code" href="classcpptempl_1_1_data_bool.html">DataBool</a> *data);</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<a class="code" href="classcpptempl_1_1_data_int.html">DataInt</a> *data);</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<a class="code" href="classcpptempl_1_1_data_value.html">DataValue</a> *data);</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<a class="code" href="classcpptempl_1_1_data_list.html">DataList</a> *data);</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<a class="code" href="classcpptempl_1_1_data_map.html">DataMap</a> *data);</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<a class="code" href="classcpptempl_1_1_data_template.html">DataTemplate</a> *data);</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<span class="keyword">const</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> &amp;data) { ptr = data.ptr; }</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> &amp;&amp;data) { ptr = std::move(data.ptr); }</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> &amp;operator=(<span class="keyword">const</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> &amp;data)</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    {</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        ptr = data.ptr;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    }</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> &amp;operator=(<a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> &amp;&amp;data)</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    {</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        ptr = std::move(data.ptr);</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    }</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> &amp;operator=(std::string &amp;&amp;data);</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> &amp;operator=(<a class="code" href="classcpptempl_1_1data__map.html">data_map</a> &amp;&amp;data);</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> &amp;operator=(data_list &amp;&amp;data);</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    <span class="keywordtype">void</span> operator=(<span class="keyword">const</span> T &amp;data);</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    <span class="keywordtype">void</span> push_back(<span class="keyword">const</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> &amp;data);</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>() {}</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    <a class="code" href="classcpptempl_1_1_data.html">Data</a> *operator-&gt;() { <span class="keywordflow">return</span> ptr.get(); }</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    std::shared_ptr&lt;Data&gt; <span class="keyword">get</span>() { <span class="keywordflow">return</span> ptr; }</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    <span class="keywordtype">bool</span> is_template() <span class="keyword">const</span>;</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    std::shared_ptr&lt;Data&gt; ptr;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;};</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;</div><div class="line"><a name="l00190"></a><span class="lineno"><a class="line" href="classcpptempl_1_1data__map.html">  190</a></span>&#160;<span class="keyword">class </span><a class="code" href="classcpptempl_1_1data__map.html">data_map</a></div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;{</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00193"></a><span class="lineno"><a class="line" href="classcpptempl_1_1data__map_1_1key__error.html">  193</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classcpptempl_1_1data__map_1_1key__error.html">key_error</a> : <span class="keyword">public</span> std::runtime_error</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    {</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        <a class="code" href="classcpptempl_1_1data__map_1_1key__error.html">key_error</a>(<span class="keyword">const</span> std::string &amp;msg)</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        : std::runtime_error(msg)</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        {</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        }</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    };</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    <a class="code" href="classcpptempl_1_1data__map.html">data_map</a>()</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    : data()</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    , parent(<span class="keyword">nullptr</span>)</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    {</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    }</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> &amp;operator[](<span class="keyword">const</span> std::string &amp;key);</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    <span class="keywordtype">bool</span> empty();</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    <span class="keywordtype">bool</span> has(<span class="keyword">const</span> std::string &amp;key);</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;    <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> &amp;parse_path(<span class="keyword">const</span> std::string &amp;key, <span class="keywordtype">bool</span> create = <span class="keyword">false</span>);</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    <span class="keywordtype">void</span> set_parent(<a class="code" href="classcpptempl_1_1data__map.html">data_map</a> *p) { parent = p; }</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    std::unordered_map&lt;std::string, data_ptr&gt; data;</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    <a class="code" href="classcpptempl_1_1data__map.html">data_map</a> *parent;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classcpptempl_1_1_data_map.html">DataMap</a>;</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;};</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno"><a class="line" href="classcpptempl_1_1_data_map.html">  220</a></span>&#160;<span class="keyword">class </span><a class="code" href="classcpptempl_1_1_data_map.html">DataMap</a> : <span class="keyword">public</span> <a class="code" href="classcpptempl_1_1_data.html">Data</a></div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;{</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    <a class="code" href="classcpptempl_1_1data__map.html">data_map</a> m_items;</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;    <a class="code" href="classcpptempl_1_1_data_map.html">DataMap</a>(<span class="keyword">const</span> <a class="code" href="classcpptempl_1_1data__map.html">data_map</a> &amp;items)</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;    : m_items(items)</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;    {</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    }</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;    <a class="code" href="classcpptempl_1_1_data_map.html">DataMap</a>(<a class="code" href="classcpptempl_1_1data__map.html">data_map</a> &amp;&amp;items)</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    : m_items(std::move(items))</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;    {</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    }</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;    <a class="code" href="classcpptempl_1_1data__map.html">data_map</a> &amp;getmap();</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;    <span class="keywordtype">bool</span> empty();</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    <span class="keywordtype">void</span> dump(<span class="keywordtype">int</span> indent = 0);</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;};</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;<span class="keyword">template</span> &lt;&gt;</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;<span class="keywordtype">void</span> data_ptr::operator=(<span class="keyword">const</span> <span class="keywordtype">bool</span> &amp;data);</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;<span class="keyword">template</span> &lt;&gt;</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;<span class="keywordtype">void</span> data_ptr::operator=(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp;data);</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;<span class="keyword">template</span> &lt;&gt;</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;<span class="keywordtype">void</span> data_ptr::operator=(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;data);</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;<span class="keyword">template</span> &lt;&gt;</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;<span class="keywordtype">void</span> data_ptr::operator=(<span class="keyword">const</span> std::string &amp;data);</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;<span class="keyword">template</span> &lt;&gt;</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;<span class="keywordtype">void</span> data_ptr::operator=(<span class="keyword">const</span> <a class="code" href="classcpptempl_1_1data__map.html">data_map</a> &amp;data);</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;<span class="keyword">template</span> &lt;&gt;</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;<span class="keywordtype">void</span> data_ptr::operator=(<span class="keyword">const</span> data_list &amp;data);</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;<span class="keywordtype">void</span> data_ptr::operator=(<span class="keyword">const</span> T &amp;data)</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;{</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;    this-&gt;operator=(boost::lexical_cast&lt;std::string&gt;(data));</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;}</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;<span class="comment">// Custom exception class for library errors</span></div><div class="line"><a name="l00257"></a><span class="lineno"><a class="line" href="classcpptempl_1_1_template_exception.html">  257</a></span>&#160;<span class="keyword">class </span><a class="code" href="classcpptempl_1_1_template_exception.html">TemplateException</a> : <span class="keyword">public</span> std::exception</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;{</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;    uint32_t m_line;</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;    std::string m_reason;</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    <a class="code" href="classcpptempl_1_1_template_exception.html">TemplateException</a>(std::string reason)</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;    : std::exception()</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;    , m_line(0)</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    , m_reason(reason)</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    {</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;    }</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;    <a class="code" href="classcpptempl_1_1_template_exception.html">TemplateException</a>(<span class="keywordtype">size_t</span> line, std::string reason);</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;    <a class="code" href="classcpptempl_1_1_template_exception.html">TemplateException</a>(<span class="keyword">const</span> <a class="code" href="classcpptempl_1_1_template_exception.html">TemplateException</a> &amp;other) = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;    <a class="code" href="classcpptempl_1_1_template_exception.html">TemplateException</a> &amp;operator=(<span class="keyword">const</span> <a class="code" href="classcpptempl_1_1_template_exception.html">TemplateException</a> &amp;other) = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classcpptempl_1_1_template_exception.html">TemplateException</a>() = <span class="keywordflow">default</span>;</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;    <span class="keywordtype">void</span> set_reason(std::string reason) { m_reason = reason; }</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    <span class="keywordtype">void</span> set_line_if_missing(<span class="keywordtype">size_t</span> line);</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span> *what() <span class="keyword">const</span> NOEXCEPT NOTHROW { <span class="keywordflow">return</span> m_reason.c_str(); }</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;};</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;<span class="comment">// convenience functions for making data objects</span></div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;<span class="keyword">inline</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> make_data(<span class="keywordtype">bool</span> val)</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;{</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<span class="keyword">new</span> <a class="code" href="classcpptempl_1_1_data_bool.html">DataBool</a>(val));</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;}</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;<span class="keyword">inline</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> make_data(<span class="keywordtype">int</span> val)</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;{</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<span class="keyword">new</span> <a class="code" href="classcpptempl_1_1_data_int.html">DataInt</a>(val));</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;}</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;<span class="keyword">inline</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> make_data(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> val)</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;{</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<span class="keyword">new</span> <a class="code" href="classcpptempl_1_1_data_int.html">DataInt</a>(val));</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;}</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;<span class="keyword">inline</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> make_data(std::string &amp;val)</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;{</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<span class="keyword">new</span> <a class="code" href="classcpptempl_1_1_data_value.html">DataValue</a>(val));</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;}</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;<span class="keyword">inline</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> make_data(std::string &amp;&amp;val)</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;{</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<span class="keyword">new</span> <a class="code" href="classcpptempl_1_1_data_value.html">DataValue</a>(val));</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;}</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;<span class="keyword">inline</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> make_data(data_list &amp;val)</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;{</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<span class="keyword">new</span> <a class="code" href="classcpptempl_1_1_data_list.html">DataList</a>(val));</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;}</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;<span class="keyword">inline</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> make_data(data_list &amp;&amp;val)</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;{</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<span class="keyword">new</span> <a class="code" href="classcpptempl_1_1_data_list.html">DataList</a>(val));</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;}</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;<span class="keyword">inline</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> make_data(<a class="code" href="classcpptempl_1_1data__map.html">data_map</a> &amp;val)</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;{</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<span class="keyword">new</span> <a class="code" href="classcpptempl_1_1_data_map.html">DataMap</a>(val));</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;}</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;<span class="keyword">inline</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> make_data(<a class="code" href="classcpptempl_1_1data__map.html">data_map</a> &amp;&amp;val)</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;{</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(<span class="keyword">new</span> <a class="code" href="classcpptempl_1_1_data_map.html">DataMap</a>(val));</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;}</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;<a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> make_data(<span class="keyword">const</span> T &amp;val)</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;{</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(boost::lexical_cast&lt;std::string&gt;(val));</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;}</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;<span class="keywordtype">void</span> dump_data(<a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> data);</div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;<span class="keyword">namespace </span>impl {</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;<span class="comment">// node classes</span></div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;<span class="keyword">class </span>Node;</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;<span class="keyword">typedef</span> std::shared_ptr&lt;Node&gt; node_ptr;</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;<span class="keyword">typedef</span> std::vector&lt;node_ptr&gt; node_vector;</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;} <span class="comment">// namespace impl</span></div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;<span class="comment">// List of param names.</span></div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;<span class="keyword">typedef</span> std::vector&lt;std::string&gt; string_vector;</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;</div><div class="line"><a name="l00337"></a><span class="lineno"><a class="line" href="classcpptempl_1_1_data_template.html">  337</a></span>&#160;<span class="keyword">class </span><a class="code" href="classcpptempl_1_1_data_template.html">DataTemplate</a> : <span class="keyword">public</span> <a class="code" href="classcpptempl_1_1_data.html">Data</a></div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;{</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;    impl::node_vector m_tree;</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;    string_vector m_params;</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;    <a class="code" href="classcpptempl_1_1_data_template.html">DataTemplate</a>(<span class="keyword">const</span> std::string &amp;templateText);</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;    <a class="code" href="classcpptempl_1_1_data_template.html">DataTemplate</a>(<span class="keyword">const</span> impl::node_vector &amp;tree)</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;    : m_tree(tree)</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;    {</div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;    }</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;    <a class="code" href="classcpptempl_1_1_data_template.html">DataTemplate</a>(impl::node_vector &amp;&amp;tree)</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;    : m_tree(std::move(tree))</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;    {</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;    }</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;    <span class="keyword">virtual</span> std::string getvalue();</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">bool</span> empty();</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;    std::string eval(<a class="code" href="classcpptempl_1_1data__map.html">data_map</a> &amp;data, data_list *param_values = <span class="keyword">nullptr</span>);</div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;    <span class="keywordtype">void</span> eval(std::ostream &amp;stream, <a class="code" href="classcpptempl_1_1data__map.html">data_map</a> &amp;data, data_list *param_values = <span class="keyword">nullptr</span>);</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;    string_vector &amp;params() { <span class="keywordflow">return</span> m_params; }</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;    <span class="keywordtype">void</span> dump(<span class="keywordtype">int</span> indent = 0);</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;};</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;<span class="keyword">inline</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a> make_template(<span class="keyword">const</span> std::string &amp;templateText, <span class="keyword">const</span> string_vector *param_names = <span class="keyword">nullptr</span>)</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;{</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;    <a class="code" href="classcpptempl_1_1_data_template.html">DataTemplate</a> *t = <span class="keyword">new</span> <a class="code" href="classcpptempl_1_1_data_template.html">DataTemplate</a>(templateText);</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;    <span class="keywordflow">if</span> (param_names)</div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;    {</div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;        t-&gt;params() = *param_names;</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;    }</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="classcpptempl_1_1data__ptr.html">data_ptr</a>(t);</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;}</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;<span class="comment">// The big daddy. Pass in the template and data,</span></div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;<span class="comment">// and get out a completed doc.</span></div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;<span class="keywordtype">void</span> parse(std::ostream &amp;stream, <span class="keyword">const</span> std::string &amp;templ_text, <a class="code" href="classcpptempl_1_1data__map.html">data_map</a> &amp;data);</div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;std::string parse(<span class="keyword">const</span> std::string &amp;templ_text, <a class="code" href="classcpptempl_1_1data__map.html">data_map</a> &amp;data);</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;}</div><div class="ttc" id="classcpptempl_1_1_data_value_html"><div class="ttname"><a href="classcpptempl_1_1_data_value.html">cpptempl::DataValue</a></div><div class="ttdef"><b>Definition:</b> cpptempl.h:111</div></div>
<div class="ttc" id="classcpptempl_1_1_data_template_html"><div class="ttname"><a href="classcpptempl_1_1_data_template.html">cpptempl::DataTemplate</a></div><div class="ttdef"><b>Definition:</b> cpptempl.h:337</div></div>
<div class="ttc" id="classcpptempl_1_1data__ptr_html"><div class="ttname"><a href="classcpptempl_1_1data__ptr.html">cpptempl::data_ptr</a></div><div class="ttdef"><b>Definition:</b> cpptempl.h:148</div></div>
<div class="ttc" id="classcpptempl_1_1_template_exception_html"><div class="ttname"><a href="classcpptempl_1_1_template_exception.html">cpptempl::TemplateException</a></div><div class="ttdef"><b>Definition:</b> cpptempl.h:257</div></div>
<div class="ttc" id="classcpptempl_1_1data__map_1_1key__error_html"><div class="ttname"><a href="classcpptempl_1_1data__map_1_1key__error.html">cpptempl::data_map::key_error</a></div><div class="ttdef"><b>Definition:</b> cpptempl.h:193</div></div>
<div class="ttc" id="classcpptempl_1_1_data_html"><div class="ttname"><a href="classcpptempl_1_1_data.html">cpptempl::Data</a></div><div class="ttdef"><b>Definition:</b> cpptempl.h:65</div></div>
<div class="ttc" id="classcpptempl_1_1_data_int_html"><div class="ttname"><a href="classcpptempl_1_1_data_int.html">cpptempl::DataInt</a></div><div class="ttdef"><b>Definition:</b> cpptempl.h:92</div></div>
<div class="ttc" id="classcpptempl_1_1_data_list_html"><div class="ttname"><a href="classcpptempl_1_1_data_list.html">cpptempl::DataList</a></div><div class="ttdef"><b>Definition:</b> cpptempl.h:130</div></div>
<div class="ttc" id="classcpptempl_1_1_data_map_html"><div class="ttname"><a href="classcpptempl_1_1_data_map.html">cpptempl::DataMap</a></div><div class="ttdef"><b>Definition:</b> cpptempl.h:220</div></div>
<div class="ttc" id="classcpptempl_1_1data__map_html"><div class="ttname"><a href="classcpptempl_1_1data__map.html">cpptempl::data_map</a></div><div class="ttdef"><b>Definition:</b> cpptempl.h:190</div></div>
<div class="ttc" id="classcpptempl_1_1_data_bool_html"><div class="ttname"><a href="classcpptempl_1_1_data_bool.html">cpptempl::DataBool</a></div><div class="ttdef"><b>Definition:</b> cpptempl.h:77</div></div>
<div class="ttc" id="namespacecpptempl_html"><div class="ttname"><a href="namespacecpptempl.html">cpptempl</a></div><div class="ttdef"><b>Definition:</b> cpptempl.h:54</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- HTML footer for doxygen 1.8.5-->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul class="foot">
    <li class="footer">&copy; 2016 NXP Semiconductors. All rights reserved.
    </li>
  </ul>
</div>
</body>
</html>
